<script>
import colors from "../../../scss/colors.scss";
import Chart from "chart.js/auto";

export default {
  name: "ContributionStatisticsByYears",
  data () {
    // do not put this inside the return-statement (https://stackoverflow.com/a/68606394), 19.10.2022 Christa Becker
    this.drawnChart = null;
    return {
      switch: "contributions",
      displayType: "charts",
      chartOptions: {
        type: "bar",
        options: {
          responsive: true,
          maintainAspectRatio: false,
          scales: {
            y: {
              beginAtZero: true,
              stacked: true
            },
            x: {
              stacked: true
            }
          },
          plugins: {
            legend: {
              display: false
            }
          }
        }
      }
    };
  },
  computed: {
    formattedChartData () {
      return {
        options: {
          scales: {
            y: {
              ticks: {
                stepSize: this.yScaleTickStepSize
              }
            }
          }
        },
        data: {
          datasets: [
            {
              data: this.contributionsByYears,
              backgroundColor: colors.color_secondary_3,
              barThickness: 30,
              minBarLength: 1,
              showTooltip: true
            },
            {
              data: this.contributionsByYears.map(elem => this.yScaleHeight - elem.y),
              backgroundColor: "rgba(" + Object.values(this.$hex2rgb(colors.color_secondary_3)).join(", ") + ", 0.15)",
              barThickness: 30,
              showTooltip: false
            }
          ]
        }
      };
    },
    contributionsByYears () {
      return this.$store.getters.contributionsByYears;
    },
    yScaleTickStepSize () {
      return Math.pow(10, this.$store.getters.maximumContributionsPerYear.toString().length - 1);
    },
    yScaleHeight () {
      return Math.ceil(this.$store.getters.maximumContributionsPerYear / this.yScaleTickStepSize) * this.yScaleTickStepSize;
    }
  },
  watch: {
    formattedChartData: {
      deep: true,
      handler () {
        this.initChart();
      }
    }
  },
  mounted () {
    this.initChart();
  },
  methods: {
    setDisplayType (type) {
      this.displayType = type;
    },
    initChart () {
      if (this.contributionsByYears.length) {
        if (this.drawnChart) {
          this.drawnChart.options = this.$mergeDeep(this.chartOptions.options, this.formattedChartData.options);
          this.drawnChart.data = this.formattedChartData.data;
        }
        else {
          this.drawnChart = new Chart(
            this.$refs.chart.getContext("2d"),
            JSON.parse(JSON.stringify(this.$mergeDeep(this.chartOptions, this.formattedChartData)))
          );
        }
        this.drawnChart.options.plugins.tooltip.filter = function (context) {
          return context.dataset.showTooltip;
        };
        this.drawnChart.update("none");
      }
    },
    translate (tid) {
      return this.$t(tid);
    }
  }
};
</script>

<template>
  <section class="ContributionStatisticsByYears">
    <div>
      <canvas
        v-show="displayType === 'charts'"
        id="contribution_statistics"
        ref="chart"
        :alt="translate('components.ContributionStatistics.altTextContributions')"
      />

      <table v-show="displayType === 'tables'">
        <thead>
          <tr>
            <th id="yearname">
              Jahr
            </th>

            <th id="contributions">
              Beiträge
            </th>
          </tr>
        </thead>

        <tbody>
          <tr
            v-for="(data) in contributionsByYears"
            :key="'row-' + data.x"
          >
            <td headers="yearname">
              {{ data.x }}
            </td>

            <td headers="yearproceeding">
              {{ data.y }}
            </td>
          </tr>
        </tbody>
      </table>
    </div>
  </section>
</template>
